/**
 * This program reads a single line the retard way :P.
 * Copyright (C) 2022  Calico <benoit.dufour@mail.com>
 * 
 * This program is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along with this program. If not, see <https://www.gnu.org/licenses/>.
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef struct string_holder
{
    char *string;
    int length;
} string_holder;

string_holder *create_new_blank_string_holder(void)
{
    string_holder *string_holder_result = (string_holder *)malloc(sizeof(string_holder));
    string_holder_result->string = (char *)malloc(sizeof(char));

    return string_holder_result;
}

void destroy_string_holder(string_holder *string_holder_in)
{
    free(string_holder_in->string);
    free(string_holder_in);
}

string_holder *read_line_from_stdio(void)
{
    // allocated on heap with malloc, could surely be allocated on stack with alloca :
    string_holder *string_holder_result = create_new_blank_string_holder();

    char current_char = getchar();
    string_holder_result->length = 0;
    while (current_char != '\n')
    {
        string_holder_result->string[string_holder_result->length] = current_char;
        string_holder_result->length = string_holder_result->length + 1;
        string_holder_result->string = realloc(string_holder_result->string, string_holder_result->length * sizeof(char));
        current_char = getchar();
    }
    string_holder_result->string = realloc(string_holder_result->string, (string_holder_result->length + 1) * sizeof(char));
    string_holder_result->string[string_holder_result->length] = '\0'; // Could be 0 instead of '\0' I guess
    return string_holder_result;
}

int main(void)
{
    printf("This program reads a single line the retard way :P.\n");
    printf("Enter something: ");
    string_holder *string_holder_input = read_line_from_stdio();
    printf("my_input value: %s\n", string_holder_input->string);
    printf("my_input length (including \\0), calculated by strlen: %zu\n", strlen(string_holder_input->string) + 1);
    printf("my_input length (including \\0), from the length variable: %d", string_holder_input->length + 1);
    destroy_string_holder(string_holder_input); // Never forget to free an allocated variable. Do it always at the right place.

    return 0;
}